<template>
  <div
    v-if="isManager!=null"
    class="container-fluid"
  >
    <h1><users-icon />Ajouter un domaine</h1>
    <hr>
    <div
      class="row"
    >
      <div
        class="col-md-12"
        style="margin-bottom: 1vh;"
      >
        <input
          class="btn btn-primary"
          type="button"
          value="Retour"
          @click="$router.push({'path':'/gestionnaire/societes'})"
        >
      </div>
      <form
        id="businessForm"
        novalidate="novalidate"
      >
        <div class="row">
          <div class="col-xs-12 col-md-6">
            <div class="form-group required">
              <label
                for="companyName"
              >Domaine&nbsp;:</label>
              <input
                id="companyName"
                v-model="personalData.companyName"
                name="companyName"
                type="text"
                class="form-control"
                required="required"
              >
            </div>
            <div class="form-group required">
              <label
                for="firstName"
              >Prénom&nbsp;:</label>
              <input
                id="firstName"
                v-model="personalData.firstname"
                name="firstName"
                type="text"
                class="form-control"
                required="required"
              >
            </div>
            <div class="form-group required">
              <label
                for="lastName"
              >Nom&nbsp;:</label>
              <input
                id="lastName"
                v-model="personalData.lastname"
                name="lastName"
                type="text"
                class="form-control"
                required="required"
              >
            </div>
            <div class="form-group required">
              <label
                for="phoneNumber"
              >Numéro de téléphone&nbsp;:</label>
              <input
                id="phoneNumber"
                v-model="personalData.phoneNumber"
                name="phoneNumber"
                type="number"
                class="form-control"
                required="required"
                minlength="10"
              >
            </div>
          </div>
          <div class="col-xs-12 col-md-6">
            <div class="form-group required">
              <label
                for="addressLine1"
              >Adresse&nbsp;:</label>
              <input
                id="addressLine1"
                v-model="personalData.addressLine1"
                name="addressLine1"
                type="text"
                class="form-control"
                required="required"
              >
            </div>
            <div class="form-group">
              <label for="addressLine2">Complément d'adresse&nbsp;:</label>
              <input
                id="addressLine2"
                v-model="personalData.addressLine2"
                name="addressLine2"
                type="text"
                class="form-control"
              >
            </div>
            <div class="form-group required">
              <label
                for="postalCode"
              >Code postal&nbsp;:</label>
              <input
                id="postalCode"
                v-model="personalData.postalCode"
                name="postalCode"
                type="number"
                maxlength="5"
                minlength="5"
                class="form-control"
                required="required"
              >
            </div>
            <div class="form-group required">
              <label
                for="city"
              >Ville&nbsp;:</label>
              <input
                id="city"
                v-model="personalData.city"
                name="city"
                type="text"
                class="form-control"
                required="required"
              >
            </div>
          </div>
          <br>
          <div
            class="row"
            style="margin-top: 1em;"
          >
            <div
              class="col-xs-12"
              style="display: flex; flex-direction: column;"
            >
              <label style="text-align: center;">Équipe(s)</label>
              <el-transfer
                v-model="selectedTeams"
                style="margin: auto; width: 100%;"
                :data="availableTeams"
                :titles="['Disponible(s)', 'Autorisée(s)']"
                :props="{
                  key: 'id',
                  label: 'description'
                }"
                filterable
                :filter-method="filterTeamsMethod"
                filter-placeholder="Rechercher"
              />
            </div>
          </div>
          <br>
        </div>
        <div class="row">
          <div
            class="form-group btn-list"
          >
            <input
              class="btn btn-primary"
              :disabled="submitDisabled"
              type="submit"
              value="Créer un nouveau domaine"
              @click="performCreateBusiness()"
            >
          </div>
        </div>
      </form>
    </div>
  </div>
  <div
    v-else
  >
    Vous n'avez pas la permission requise pour afficher ces informations.
  </div>
</template>

<script>
import UsersIcon from "../../../components/Icon/UsersIcon";
import {mapActions, mapGetters} from "vuex";
import VanillaToasts from "vanillatoasts";
export default {
  name: "ManagerAddBusiness",
  components: {UsersIcon},
  data() {
    return {
      selectedTeams: [],
      availableTeams: [],
      validator: null,
    }
  },
  computed: {
    ...mapGetters([
      'isManager',
      'teams',
      'business',
      'personalData'
    ]),
    submitDisabled: function() {
      return this.isLoading
          || this.personalData.companyName.length === 0
          || this.personalData.firstname.length === 0
          || this.personalData.lastname.length === 0
          || this.personalData.phoneNumber.length === 0
          || this.personalData.addressLine1.length === 0
          || this.personalData.postalCode.length === 0
          || this.personalData.city.length === 0
          || this.selectedTeams.length === 0
    }
  },
  created() {
    this.fetchTeams().then(()=>{
      this.teams.forEach(team => {
        if(this.selectedTeams.length === 0) {
          this.selectedTeams.push(team.id)
        }
        this.availableTeams.push(team)
      })
    })
  },
  mounted() {
    this.validator = $('#businessForm').submit(function (e) {
      e.preventDefault();
    }).validate({
      rules: {
        companyName: 'required',
        firstname: 'required',
        lastname: 'required',
        addressLine1: 'required',
        postalCode: {
          required: true,
          maxlength: 5,
          minlength: 5,
          digits: true
        },
        phoneNumber: {
          required: true,
          maxlength: 10,
          minlength: 10,
          digits: true
        },
        city: 'required',
      },
      errorElement: 'em',
      errorPlacement: function (error, element) {
        // Add the `help-block` class to the error element
        error.addClass('help-block');

        if (element.prop("type") === 'checkbox') {
          error.insertAfter(element.parent('label'));
        } else {
          error.insertAfter(element);
        }
      },
      highlight: function (element) {
        $(element).parents(".form-group").addClass("has-error").removeClass("has-success");
      },
      unhighlight: function (element) {
        $(element).parents(".form-group").addClass("has-success").removeClass("has-error");
      }
    });
  },
  methods: {
    ...mapActions([
      'fetchBusinesses',
      'addBusiness',
      'createBusiness',
      'loadingStarts',
      'loadingEnds',
      'fetchTeams',
      'createPersonalData'
    ]),
    async addTeamBusiness() {
      for(const teamId of this.selectedTeams) {
        await this.addBusiness({
          teamId: teamId,
          businessId: this.business.id
        })
      }
    },
    performCreateBusiness() {
      if ($("#businessForm").valid()) {
        this.loadingStarts()
        this.createBusiness().then((business)=> {
          this.personalData.userId = business.id
          this.createPersonalData(this.personalData).then(()=> {
            this.addTeamBusiness().then(()=>{
              this.fetchBusinesses().then(()=>{
                VanillaToasts.create({
                  title: 'Ajout domaine',
                  text: 'Domaine créé avec succès.',
                  type: 'success',
                  timeout: 10000,
                });
                this.loadingEnds()
                this.$router.push({ path: '/gestionnaire/societes'})
              })
            })
          })
        })
      }
    },
    filterTeamsMethod(query, item) {
      return item.description.toLowerCase().indexOf(query.toLowerCase()) > -1;
    },
  }
}
</script>

<style scoped>

</style>